module.exports = (function() {
	Object.prototype.containsKey = function(key) {
		return this.hasOwnProperty(key);
	}
	Object.prototype.push = function(element) {
		var key = this.generateGUID();
		this[key] = element;
		return key;
	}
	Object.prototype.generateGUID = function() {
		function s4() { return Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1); }
		var key = s4() + s4() + '-' + s4() + s4() + '-' + s4() + s4() + '-' + s4() + s4();
		if(!this.hasOwnProperty(key)) return key;
		else return this.generateGUID();
	}
	Object.prototype.find = function(element) {
		for(var i=0;i<Object.keys(this).length;i++) {
			var itemIndex = Object.keys(this)[i];
			var item = this[itemIndex];
			if(JSON.stringify(item) === JSON.stringify(element)) {
				return itemIndex;
			} else {
				return -1;
			}
		}
	}
	Object.prototype.contains = function(element) {
		for(var i=0;i<Object.keys(this).length;i++) {
			var itemIndex = Object.keys(this)[i];
			var item = this[itemIndex];
			if(JSON.stringify(item) === JSON.stringify(element)) return true;
		}
		return false;
	}
	Object.prototype.remove = function(element)	{
		var index = -1;
		for(var i=0;i<Object.keys(this).length;i++) {
			var itemIndex = Object.keys(this)[i];
			var item = this[itemIndex];
			if(JSON.stringify(item) === JSON.stringify(element)) index = itemIndex;
		}
		delete this[index];
	}
	Object.prototype.length = function() {
		return Object.keys(this).length;
	}
	Object.prototype.forEach = function(callback) {
		if(callback != null && typeof(callback) == 'function') {
			for(var i=0;i<Object.keys(this).length;i++) {
				var element = this[Object.keys(this)[i]];
				callback(element);
			}
		}
	}
})();