const Client = require('./parse.client');
const Room = require('./parse.room');

module.exports = function(parse) {
	parse.io.on('connection', socket => {
		this.connect(socket);
		socket.on('disconnect', () => this.disconnect(socket));
		socket.on('create_room', roomData => parse.createRoom(roomData));
		socket.on('delete_room', roomID => parse.deleteRoom(roomID));
		socket.on('join_room', roomID => parse.joinRoom(socket, roomID));
		socket.on('leave_room', roomID => parse.leaveRoom(socket, roomID));
		socket.on('send_packet', packetData => parse.sendPacket(socket, packetData));
	});

	connect = function(socket) {
		if(!parse.clients.containsKey(socket.id)) {
			var username = socket.request._query['username'];
			var client = new Client({ id: socket.id, username });
			parse.broadcast(socket, 'client_connect', client);
			socket.emit('get_server_info', parse.getServerInfo());
			parse.clients[socket.id] = client;
			parse.updateStats();
			parse.joinRoom(socket, parse.generalRoomID);
		}
	}

	disconnect = function(socket) {
		if(parse.clients.containsKey(socket.id)) {
			var client = parse.clients[socket.id];
			var room = parse.rooms[client.currentRoomID];
			parse.leaveRoom(socket, client.currentRoomID);
			parse.broadcast(socket, 'client_disconnect', client);
			parse.clients.remove(client);
			parse.updateStats();
		}
	}
}