function Room(data) {
	this.id = null;
	this.parse = data.parse;
	this.name = data.name;
	this.creator = data.creator;
	this.clients = {};
}

Room.prototype.join = function(client, socket) {
	if(!this.clients.containsKey(socket.id)) {
		this.clients[socket.id] = client;
		client.currentRoomID = this.id;
		socket.join(this.id);
		console.log(client.username, 'joined', this.name, '- online:' + this.clients.length());
	}
}

Room.prototype.leave = function(client, socket) {
	if(this.clients.containsKey(socket.id)) {
		var client = this.clients[socket.id];
		this.clients.remove(client);
		socket.leave(this.id);
		console.log(client.username, 'left', this.name, '- online:' + this.clients.length());
	}
}

Room.prototype.broadcast = function(socket, evt, data) {
	socket.broadcast.to(this.id).emit(evt, data);
}

Room.prototype.broadcastAll = function(evt, data) {
	this.parse.io.in(this.id).emit(evt, data);
}

module.exports = Room;